
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for IDLByte. See the comments in IDLByte.h
//
// jhrg 9/24/96

// $Log: IDLByte.cc,v $
// Revision 1.3  2000/07/09 22:17:51  rmorris
// Include use <header> instead of <header.h> for headers in the standard
// c++ library - this increases portability.
//
// Revision 1.2  1999/11/09 05:57:09  jimg
// Result of merge with release-3-1-1
//
// Revision 1.1.2.1  1999/09/23 23:06:25  jimg
// This collection of files builds under Solaris 2.6. The resulting idl_dods.so
// runs correctly on the fnoc1.nc test dataset.
//

#ifdef __GNUG__
#pragma implementation
#endif

// The NewByte `helper function' creates a pointer to the a IDLByte and
// returns that pointer. It takes the same arguments as the class's ctor. If
// any of the variable classes are subclassed (e.g., to make a new Byte like
// HDFByte) then the corresponding function here, and in the other class
// definition files, needs to be changed so that it creates an instnace of
// the new (sub)class. Continuing the earlier example, that would mean that
// NewByte() would return a HDFByte, not a Byte.
//
// It is important that these function's names and return types do not change
// - they are called by the parser code (for the dds, at least) so if their
// names changes, that will break.
//
// The declarations for these fuctions (in util.h) should *not* need
// changing. 

#if 0
#include <stdio.h>
#endif
#include <assert.h>

#if 0
#include <iostream>
#include <Pix.h>
#include <SLList.h>
#endif
#include <string>

#include "IDLByte.h"
#if 0
#include "name_map.h"
#endif

#if 0
extern name_map names;
extern bool translate;
extern bool ascii;
#endif

Byte *
NewByte(const string &n)
{
    return new IDLByte(n);
}

IDLByte::IDLByte(const string &n) : Byte(n)
{
}

BaseType *
IDLByte::ptr_duplicate()
{
    return new IDLByte(*this);
}

bool
IDLByte::read(const string &, int &)
{
    assert(false);
    return false;
}

#if 0
void 
IDLByte::print_val(ostream &os, string, bool print_decl_p)
{
    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (translate) {
	dods_float64 df = _buf;
	if (ascii)
	    os << df << " ";
	else
	    os.write((void *)&df, sizeof(dods_float64));
    }
    else {
	if (ascii)
	    os << (unsigned int)_buf << " ";
	else
	    os.write((void *)&_buf, sizeof(dods_byte));
    }	
}
#endif
